## openssh 7.5p1

=== debian/changelog ===
openssh (1:7.5p1-10ubuntu0.1) artful-security; urgency=medium

  * SECURITY UPDATE: DoS via zero-length file creation in readonly mode
    - debian/patches/CVE-2017-15906.patch: disallow creation of empty files
      in sftp-server.c.
    - CVE-2017-15906

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 16 Jan 2018 08:28:47 -0500

openssh (1:7.5p1-10) unstable; urgency=medium

  * Tell haveged to create the pid file we expect.
  * Give up and use systemctl to start haveged if running under systemd;
    this shouldn't be necessary, but I can't seem to get things working in
    the Ubuntu autopkgtest environment otherwise.

 -- Colin Watson <cjwatson@debian.org>  Fri, 01 Sep 2017 11:17:19 +0100

openssh (1:7.5p1-9) unstable; urgency=medium

  * Run debian/tests/regress with "set -x".
  * Run haveged without "-w 1024", as setting the low water mark doesn't
    seem possible in all autopkgtest virtualisation environments.

 -- Colin Watson <cjwatson@debian.org>  Thu, 31 Aug 2017 13:23:04 +0100

openssh (1:7.5p1-8) unstable; urgency=medium

  * Drop openssh-client-ssh1, now built by a separate source package.
  * Run haveged during autopkgtests to ensure that they have enough entropy
    for key generation (LP: #1712921).
  * Apply patches from https://bugzilla.mindrot.org/show_bug.cgi?id=2752 to
    allow some extra syscalls for crypto cards on s390x (LP: #1686618).

 -- Colin Watson <cjwatson@debian.org>  Mon, 28 Aug 2017 12:16:35 +0100

openssh (1:7.5p1-7) unstable; urgency=medium

  * Fix spelling of RuntimeDirectoryMode (closes: #872976).
  * Add RuntimeDirectory and RuntimeDirectoryMode to ssh@.service as well as
    ssh.service (closes: #872978).

 -- Colin Watson <cjwatson@debian.org>  Wed, 23 Aug 2017 12:12:59 +0100

openssh (1:7.5p1-6) unstable; urgency=medium

  [ Colin Watson ]
  * Test configuration before starting or reloading sshd under systemd
    (closes: #865770).
  * Create /run/sshd under systemd using RuntimeDirectory rather than
    tmpfiles.d (thanks, Dmitry Smirnov; closes: #864190).

  [ Dimitri John Ledkov ]
  * Drop upstart system and user jobs (closes: #872851).

  [ Chris Lamb ]
  * Quote IP address in suggested "ssh-keygen -f" calls (closes: #872643).

 -- Colin Watson <cjwatson@debian.org>  Wed, 23 Aug 2017 01:41:06 +0100

openssh (1:7.5p1-5) unstable; urgency=medium

  * Upload to unstable.
  * Fix syntax error in debian/copyright.

 -- Colin Watson <cjwatson@debian.org>  Sun, 18 Jun 2017 12:08:42 +0100

openssh (1:7.5p1-4) experimental; urgency=medium

  * Drop README.Debian section on privilege separation, as it's no longer
    optional.
  * Only call "initctl set-env" from agent-launch if $UPSTART_SESSION is set
    (LP: #1689299).
  * Fix incoming compression statistics (thanks, Russell Coker; closes:
    #797964).
  * Relicense debian/* under a two-clause BSD licence for bidirectional
    compatibility with upstream, with permission from Matthew Vernon and
    others.

 -- Colin Watson <cjwatson@debian.org>  Tue, 06 Jun 2017 15:17:58 +0100

openssh (1:7.5p1-3) experimental; urgency=medium

  * Fix debian/adjust-openssl-dependencies to account for preferring
    libssl1.0-dev.
  * Adjust OpenSSL dependencies for openssh-client-ssh1 too.
  * Fix purge failure when /etc/ssh has already somehow been removed
    (LP: #1682817).
  * Ensure that /etc/ssh exists before trying to create /etc/ssh/sshd_config
    (LP: #1685022).

 -- Colin Watson <cjwatson@debian.org>  Tue, 02 May 2017 13:51:27 +0100

openssh (1:7.5p1-2) experimental; urgency=medium

  * Add missing header on Linux/s390.
  * Fix syntax error on Linux/X32.

 -- Colin Watson <cjwatson@debian.org>  Sun, 02 Apr 2017 13:20:11 +0100

openssh (1:7.5p1-1) experimental; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-7.5):
    - SECURITY: ssh(1), sshd(8): Fix weakness in CBC padding oracle
      countermeasures that allowed a variant of the attack fixed in OpenSSH
      7.3 to proceed.  Note that the OpenSSH client disables CBC ciphers by
      default, sshd offers them as lowest-preference options and will remove
      them by default entirely in the next release.
    - This release deprecates the sshd_config UsePrivilegeSeparation option,
      thereby making privilege separation mandatory (closes: #407754).
    - The format of several log messages emitted by the packet code has
      changed to include additional information about the user and their
      authentication state.  Software that monitors ssh/sshd logs may need
      to account for these changes.
    - ssh(1), sshd(8): Support "=-" syntax to easily remove methods from
      algorithm lists, e.g. Ciphers=-*cbc.
    - sshd(1): Fix NULL dereference crash when key exchange start messages
      are sent out of sequence.
    - ssh(1), sshd(8): Allow form-feed characters to appear in configuration
      files.
    - sshd(8): Fix regression in OpenSSH 7.4 support for the server-sig-algs
      extension, where SHA2 RSA signature methods were not being correctly
      advertised.
    - ssh(1), ssh-keygen(1): Fix a number of case-sensitivity bugs in
      known_hosts processing.
    - ssh(1): Allow ssh to use certificates accompanied by a private key
      file but no corresponding plain *.pub public key.
    - ssh(1): When updating hostkeys using the UpdateHostKeys option, accept
      RSA keys if HostkeyAlgorithms contains any RSA keytype.  Previously,
      ssh could ignore RSA keys when only the ssh-rsa-sha2-* methods were
      enabled in HostkeyAlgorithms and not the old ssh-rsa method.
    - ssh(1): Detect and report excessively long configuration file lines.
    - Merge a number of fixes found by Coverity and reported via Redhat and
      FreeBSD.  Includes fixes for some memory and file descriptor leaks in
      error paths.
    - ssh(1), sshd(8): When logging long messages to stderr, don't truncate
      "\r\n" if the length of the message exceeds the buffer.


=== debian/control ===
Source: openssh
Section: net
Priority: standard
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
Build-Depends: autotools-dev,
               debhelper (>= 9~),
               dh-autoreconf,
               dh-exec,
               dh-systemd (>= 1.4),
               dpkg-dev (>= 1.16.1~),
               libaudit-dev [linux-any],
               libedit-dev,
               libgtk-3-dev,
               libkrb5-dev | heimdal-dev,
               libpam0g-dev | libpam-dev,
               libselinux1-dev [linux-any],
               libssl1.0-dev | libssl-dev (<< 1.1.0~),
               libsystemd-dev [linux-any],
               libwrap0-dev | libwrap-dev,
               zlib1g-dev (>= 1:1.2.3),
Standards-Version: 3.9.8
Uploaders: Colin Watson <cjwatson@debian.org>,
           Matthew Vernon <matthew@debian.org>,
Homepage: http://www.openssh.com/
Vcs-Git: https://anonscm.debian.org/git/pkg-ssh/openssh.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ssh/openssh.git

Package: openssh-client
Architecture: any
Depends: adduser (>= 3.10),
         dpkg (>= 1.7.0),
         passwd,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: xauth,
Conflicts: sftp,
Replaces: ssh,
          ssh-krb5,
Suggests: keychain,
          libpam-ssh,
          monkeysphere,
          ssh-askpass,
Provides: rsh-client,
          ssh-client,
Multi-Arch: foreign
Description: secure shell (SSH) client, for secure access to remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the ssh, scp and sftp clients, the ssh-agent
 and ssh-add programs to make public key authentication more convenient,
 and the ssh-keygen, ssh-keyscan, ssh-copy-id and ssh-argv0 utilities.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 ssh replaces the insecure rsh, rcp and rlogin programs, which are
 obsolete for most purposes.

Package: openssh-server
Priority: optional
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser (>= 3.9),
         dpkg (>= 1.9.0),
         libpam-modules (>= 0.72-9),
         libpam-runtime (>= 0.76-14),
         lsb-base (>= 4.1+Debian3),
         openssh-client (= ${binary:Version}),
         openssh-sftp-server,
         procps,
         ucf (>= 0.28),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: libpam-systemd,
            ncurses-term,
            xauth,
            ${openssh-server:Recommends},
Conflicts: sftp,
           ssh-socks,
           ssh2,
Replaces: ssh,
          ssh-krb5,
Suggests: molly-guard,
          monkeysphere,
          rssh,
          ssh-askpass,
          ufw,
Provides: ssh-server,
Multi-Arch: foreign
Description: secure shell (SSH) server, for secure access from remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the sshd server.
 .
 In some countries it may be illegal to use any encryption at all
 without a special permit.
 .
 sshd replaces the insecure rshd program, which is obsolete for most
 purposes.

Package: openssh-sftp-server
Priority: optional
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Recommends: openssh-server | ssh-server,
Breaks: openssh-server (<< 1:6.5p1-5),
Replaces: openssh-server (<< 1:6.5p1-5),
Enhances: openssh-server,
          ssh-server,
Description: secure shell (SSH) sftp server module, for SFTP access from remote machines
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 Ssh (Secure Shell) is a program for logging into a remote machine
 and for executing commands on a remote machine.
 It provides secure encrypted communications between two untrusted
 hosts over an insecure network. X11 connections and arbitrary TCP/IP
 ports can also be forwarded over the secure channel.
 It can be used to provide applications with a secure communication
 channel.
 .
 This package provides the SFTP server module for the SSH server. It
 is needed if you want to access your SSH server with SFTP. The SFTP
 server module also works with other SSH daemons like dropbear.
 .
 OpenSSH's sftp and sftp-server implement revision 3 of the SSH filexfer
 protocol described in:
 .
  http://www.openssh.com/txt/draft-ietf-secsh-filexfer-02.txt
 .
 Newer versions of the draft will not be supported, though some features
 are individually implemented as extensions.

Package: ssh
Priority: extra
Architecture: all
Pre-Depends: dpkg (>= 1.17.5),
Depends: openssh-client (>= ${binary:Version}),
         openssh-server (>= ${binary:Version}),
         ${misc:Depends},
Description: secure shell client and server (metapackage)
 This metapackage is a convenient way to install both the OpenSSH client
 and the OpenSSH server. It provides nothing in and of itself, so you
 may remove it if nothing depends on it.

Package: ssh-krb5
Section: oldlibs
Priority: extra
Architecture: all
Depends: openssh-client (>= ${binary:Version}),
         openssh-server (>= ${binary:Version}),
         ${misc:Depends},
Description: secure shell client and server (transitional package)
 This is a transitional package depending on the regular Debian OpenSSH
 client and server, which now support GSSAPI natively. It will add the
 necessary GSSAPI options to the server configuration file. You can
 remove it once the upgrade is complete and nothing depends on it.

Package: ssh-askpass-gnome
Section: gnome
Priority: optional
Architecture: any
Depends: openssh-client | ssh (>= 1:1.2pre7-4) | ssh-krb5,
         ${misc:Depends},
         ${shlibs:Depends},
Replaces: ssh (<< 1:3.5p1-3),
Provides: ssh-askpass,
Description: interactive X program to prompt users for a passphrase for ssh-add
 This has been split out of the main openssh-client package so that
 openssh-client does not need to depend on GTK+.
 .
 You probably want the ssh-askpass package instead, but this is
 provided to add to your choice and/or confusion.

Package: openssh-client-udeb
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends: ${shlibs:Depends},
XB-Installer-Menu-Item: 99999
Description: secure shell client for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the ssh client for use in debian-installer.

Package: openssh-server-udeb
Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: any
Depends: ${shlibs:Depends},
Description: secure shell server for the Debian installer
 This is the portable version of OpenSSH, a free implementation of
 the Secure Shell protocol as specified by the IETF secsh working
 group.
 .
 This package provides the sshd server for use in debian-installer.
 Since it is expected to be used in specialized situations (e.g. S/390
 installs with no console), it does not provide any configuration.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  RUN_TESTS := yes
else
  RUN_TESTS :=
endif

ifeq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  PARALLEL :=
else
  PARALLEL := \
	-j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
  CC := gcc
  PKG_CONFIG = pkg-config
else
  CC := $(DEB_HOST_GNU_TYPE)-gcc
  PKG_CONFIG = $(DEB_HOST_GNU_TYPE)-pkg-config
  RUN_TESTS :=
endif

DEB_HOST_ARCH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)

# Take account of old dpkg-architecture output.
ifeq ($(DEB_HOST_ARCH_OS),)
  DEB_HOST_ARCH_OS := $(subst -gnu,,$(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM))
  ifeq ($(DEB_HOST_ARCH_OS),gnu)
    DEB_HOST_ARCH_OS := hurd
  endif
endif

# Change the version string to reflect distribution
DISTRIBUTION := $(shell dpkg-vendor --query vendor)
SSH_EXTRAVERSION := $(DISTRIBUTION)-$(shell dpkg-parsechangelog | sed -n -e '/^Version:/s/Version: //p' | sed -e 's/[^-]*-//')

DISTRIBUTOR := $(shell if dpkg-vendor --derives-from Ubuntu 2>/dev/null; then echo Ubuntu; else echo Debian; fi)
ifeq ($(DISTRIBUTOR),Ubuntu)
DEFAULT_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/games
else
DEFAULT_PATH := /usr/local/bin:/usr/bin:/bin:/usr/games
endif
SUPERUSER_PATH := /usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

ifeq ($(DISTRIBUTOR),Ubuntu)
server_recommends := ssh-import-id
else
server_recommends :=
endif

# Common path configuration.
confflags += --sysconfdir=/etc/ssh
confflags += --libexecdir=\$${prefix}/lib/openssh

# Common build options.
confflags += --disable-strip
confflags += --with-mantype=doc
confflags += --with-4in6
confflags += --with-privsep-path=/run/sshd
confflags += --with-pid-dir=/run

# The Hurd needs libcrypt for res_query et al.
ifeq ($(DEB_HOST_ARCH_OS),hurd)
confflags += --with-libs=-lcrypt
endif

# http://gcc.gnu.org/bugzilla/show_bug.cgi?id=60155
ifeq ($(DEB_HOST_ARCH),hppa)
confflags += --without-hardening
endif

# Everything above here is common to the deb and udeb builds.
confflags_udeb := $(confflags)

# Options specific to the deb build.
confflags += --with-tcp-wrappers
confflags += --with-pam
confflags += --with-libedit
confflags += --with-kerberos5=/usr
confflags += --with-ssl-engine
ifeq ($(DEB_HOST_ARCH_OS),linux)
confflags += --with-selinux
confflags += --with-audit=linux
confflags += --with-systemd
endif

# The deb build wants xauth; the udeb build doesn't.
confflags += --with-xauth=/usr/bin/xauth
confflags_udeb += --without-xauth

# Default paths. The udeb build has /usr/games removed.
confflags += --with-default-path=$(DEFAULT_PATH) --with-superuser-path=$(SUPERUSER_PATH)
confflags_udeb += --with-default-path=/usr/local/bin:/usr/bin:/bin --with-superuser-path=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin

# Compiler flags.
export DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/buildflags.mk
cflags := $(CPPFLAGS) $(CFLAGS)
cflags += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
cflags_udeb := -Os
cflags_udeb += -DSSH_EXTRAVERSION=\"$(SSH_EXTRAVERSION)\"
confflags += --with-cflags='$(cflags)'
confflags_udeb += --with-cflags='$(cflags_udeb)'

# Linker flags.
confflags += --with-ldflags='$(strip -Wl,--as-needed $(LDFLAGS))'
confflags_udeb += --with-ldflags='-Wl,--as-needed'

%:
	dh $@ --with=autoreconf,systemd

autoreconf:
	autoreconf -f -i
	cp -f /usr/share/misc/config.guess /usr/share/misc/config.sub ./

override_dh_autoreconf-arch:
	dh_autoreconf debian/rules -- autoreconf

override_dh_autoreconf-indep:

override_dh_auto_configure-arch:
	dh_auto_configure -Bdebian/build-deb -- $(confflags)
	dh_auto_configure -Bdebian/build-udeb -- $(confflags_udeb)

override_dh_auto_configure-indep:

override_dh_auto_build-arch:
	# Avoid libnsl linkage. Ugh.
	perl -pi -e 's/ +-lnsl//' debian/build-udeb/config.status
	cd debian/build-udeb && ./config.status

	$(MAKE) -C debian/build-deb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass'
	$(MAKE) -C debian/build-udeb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass' ssh scp sftp sshd ssh-keygen

	$(MAKE) -C contrib gnome-ssh-askpass3 CC='$(CC) $(CPPFLAGS) $(CFLAGS) -Wall -Wl,--as-needed $(LDFLAGS)' PKG_CONFIG=$(PKG_CONFIG)

override_dh_auto_build-indep:

override_dh_auto_test-arch:
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/build-deb regress-prep
	$(MAKE) -C debian/build-deb $(PARALLEL) regress-binaries
	$(MAKE) -C debian/build-deb/regress \
		.OBJDIR="$(CURDIR)/debian/build-deb/regress" \
		.CURDIR="$(CURDIR)/regress" \
		unit
	$(MAKE) -C debian/build-deb compat-tests
	$(MAKE) -C debian/keygen-test
endif

override_dh_auto_test-indep:

override_dh_auto_clean:
	rm -rf debian/build-deb debian/build-udeb
ifeq ($(RUN_TESTS),yes)
	$(MAKE) -C debian/keygen-test clean
endif
	$(MAKE) -C contrib clean

override_dh_auto_install-arch:
	$(MAKE) -C debian/build-deb DESTDIR=`pwd`/debian/tmp install-nokeys

override_dh_auto_install-indep:

override_dh_install-arch:
	rm -f debian/tmp/etc/ssh/sshd_config

	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb --fail-missing
	dh_install -popenssh-client-udeb -popenssh-server-udeb \
		--sourcedir=debian/build-udeb

	# Remove version control tags to avoid unnecessary conffile
	# resolution steps for administrators.
	sed -i '/\$$OpenBSD:/d' \
		debian/openssh-client/etc/ssh/moduli \
		debian/openssh-client/etc/ssh/ssh_config

# We'd like to use dh_install --fail-missing here, but that doesn't work
# well in combination with dh-exec: it complains that files generated by
# dh-exec for architecture-dependent packages aren't installed.
override_dh_install-indep:
	rm -f debian/tmp/etc/ssh/sshd_config
	dh_install

override_dh_installdocs:
	dh_installdocs -Nopenssh-server -Nopenssh-sftp-server
	dh_installdocs -popenssh-server -popenssh-sftp-server \
		--link-doc=openssh-client
	# Avoid breaking dh_installexamples later.
	mkdir -p debian/openssh-server/usr/share/doc/openssh-client

override_dh_systemd_enable:
	dh_systemd_enable -popenssh-server --name ssh ssh.service
	dh_systemd_enable -popenssh-server --name ssh --no-enable ssh.socket

override_dh_installinit:
	dh_installinit -R --name ssh

debian/openssh-server.sshd.pam: debian/openssh-server.sshd.pam.in
ifeq ($(DEB_HOST_ARCH_OS),linux)
	sed 's/^@IF_KEYINIT@//' $< > $@
else
	sed '/^@IF_KEYINIT@/d' $< > $@
endif

override_dh_installpam: debian/openssh-server.sshd.pam
	dh_installpam --name sshd

override_dh_fixperms-arch:
	dh_fixperms
	chmod u+s debian/openssh-client/usr/lib/openssh/ssh-keysign

# Tighten libssl dependencies to match the check in entropy.c.
override_dh_shlibdeps:
	dh_shlibdeps
	debian/adjust-openssl-dependencies

override_dh_gencontrol:
	dh_gencontrol -- -V'openssh-server:Recommends=$(server_recommends)'

override_dh_builddeb:
	dh_builddeb -- -Zxz

debian/faq.html:
	wget -O - http://www.openssh.com/faq.html | \
		sed 's,\(href="\)\(txt/\|[^":]*\.html\),\1http://www.openssh.com/\2,g' \
		> debian/faq.html

## openssh 7.6p1

=== regress/Makefile ===
#	$OpenBSD: Makefile,v 1.95 2017/06/24 06:35:24 djm Exp $

REGRESS_TARGETS=	unit t1 t2 t3 t4 t5 t6 t7 t8 t9 t10 t11 t12 t-exec
tests:		prep $(REGRESS_TARGETS)

# Interop tests are not run by default
interop interop-tests: t-exec-interop

prep:
	test "x${USE_VALGRIND}" = "x" || mkdir -p $(OBJ)/valgrind-out

clean:
	for F in $(CLEANFILES); do rm -f $(OBJ)$$F; done
	test -z "${SUDO}" || ${SUDO} rm -f ${SUDO_CLEAN}
	rm -rf $(OBJ).putty

distclean:	clean

LTESTS= 	connect \
		proxy-connect \
		connect-privsep \
		proto-version \
		proto-mismatch \
		exit-status \
		envpass \
		transfer \
		banner \
		rekey \
		stderr-data \
		stderr-after-eof \
		broken-pipe \
		try-ciphers \
		yes-head \
		login-timeout \
		agent \
		agent-getpeereid \
		agent-timeout \
		agent-ptrace \
		keyscan \
		keygen-change \
		keygen-convert \
		keygen-moduli \
		key-options \
		scp \
		sftp \
		sftp-chroot \
		sftp-cmds \
		sftp-badcmds \
		sftp-batch \
		sftp-glob \
		sftp-perm \
		reconfigure \
		dynamic-forward \
		forwarding \
		multiplex \
		reexec \
		brokenkeys \
		sshcfgparse \
		cfgparse \
		cfgmatch \
		addrmatch \
		localcommand \
		forcecommand \
		portnum \
		keytype \
		kextype \
		cert-hostkey \
		cert-userkey \
		host-expand \
		keys-command \
		forward-control \
		integrity \
		krl \
		multipubkey \
		limit-keytype \
		hostkey-agent \
		keygen-knownhosts \
		hostkey-rotate \
		principals-command \
		cert-file \
		cfginclude \
		allow-deny-users \
		authinfo


#		dhgex \

INTEROP_TESTS=	putty-transfer putty-ciphers putty-kex conch-ciphers
#INTEROP_TESTS+=ssh-com ssh-com-client ssh-com-keygen ssh-com-sftp

#LTESTS= 	cipher-speed

USERNAME=		${LOGNAME}
CLEANFILES=	*.core actual agent-key.* authorized_keys_${USERNAME} \
		authorized_keys_${USERNAME}.* \
		authorized_principals_${USERNAME} \
		banner.in banner.out cert_host_key* cert_user_key* \
		copy.1 copy.2 data ed25519-agent ed25519-agent* \
		ed25519-agent.pub ed25519 ed25519.pub empty.in \
		expect failed-regress.log failed-ssh.log failed-sshd.log \
		hkr.* host.ed25519 host.rsa host.rsa1 host_* \
		host_ca_key* host_krl_* host_revoked_* key.* \
		key.dsa-* key.ecdsa-* key.ed25519-512 \
		key.ed25519-512.pub key.rsa-* keys-command-args kh.* \
		known_hosts known_hosts-cert known_hosts.* krl-* ls.copy \
		modpipe netcat no_identity_config \
		pidfile putty.rsa2 ready regress.log \
		remote_pid revoked-* rsa rsa-agent rsa-agent.pub rsa.pub \
		rsa1 rsa1-agent rsa1-agent.pub rsa1.pub rsa_ssh2_cr.prv \
		rsa_ssh2_crnl.prv scp-ssh-wrapper.exe \
		scp-ssh-wrapper.scp setuid-allowed sftp-server.log \
		sftp-server.sh sftp.log ssh-log-wrapper.sh ssh.log \
		ssh_config ssh_config.* ssh_proxy ssh_proxy_bak \
		ssh_proxy_envpass sshd.log sshd_config sshd_config_minimal \
		sshd_config.orig sshd_proxy sshd_proxy.* sshd_proxy_bak \
		sshd_proxy_orig t10.out t10.out.pub t12.out t12.out.pub \
		t2.out t3.out t6.out1 t6.out2 t7.out t7.out.pub \
		t8.out t8.out.pub t9.out t9.out.pub testdata \
		user_*key* user_ca* user_key*

SUDO_CLEAN+=	/var/run/testdata_${USERNAME} /var/run/keycommand_${USERNAME}

# Enable all malloc(3) randomisations and checks
TEST_ENV=      "MALLOC_OPTIONS=CFGJRSUX"

TEST_SSH_SSHKEYGEN?=ssh-keygen

CPPFLAGS=-I..

t1:
	${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/rsa_ssh2.prv | diff - ${.CURDIR}/rsa_openssh.prv
	tr '\n' '\r' <${.CURDIR}/rsa_ssh2.prv > ${.OBJDIR}/rsa_ssh2_cr.prv
	${TEST_SSH_SSHKEYGEN} -if ${.OBJDIR}/rsa_ssh2_cr.prv | diff - ${.CURDIR}/rsa_openssh.prv
	awk '{print $$0 "\r"}' ${.CURDIR}/rsa_ssh2.prv > ${.OBJDIR}/rsa_ssh2_crnl.prv
	${TEST_SSH_SSHKEYGEN} -if ${.OBJDIR}/rsa_ssh2_crnl.prv | diff - ${.CURDIR}/rsa_openssh.prv

t2:
	cat ${.CURDIR}/rsa_openssh.prv > $(OBJ)/t2.out
	chmod 600 $(OBJ)/t2.out
	${TEST_SSH_SSHKEYGEN} -yf $(OBJ)/t2.out | diff - ${.CURDIR}/rsa_openssh.pub

t3:
	${TEST_SSH_SSHKEYGEN} -ef ${.CURDIR}/rsa_openssh.pub >$(OBJ)/t3.out
	${TEST_SSH_SSHKEYGEN} -if $(OBJ)/t3.out | diff - ${.CURDIR}/rsa_openssh.pub

t4:
	${TEST_SSH_SSHKEYGEN} -E md5 -lf ${.CURDIR}/rsa_openssh.pub |\
		awk '{print $$2}' | diff - ${.CURDIR}/t4.ok

t5:
	${TEST_SSH_SSHKEYGEN} -Bf ${.CURDIR}/rsa_openssh.pub |\
		awk '{print $$2}' | diff - ${.CURDIR}/t5.ok

t6:
	${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/dsa_ssh2.prv > $(OBJ)/t6.out1
	${TEST_SSH_SSHKEYGEN} -if ${.CURDIR}/dsa_ssh2.pub > $(OBJ)/t6.out2
	chmod 600 $(OBJ)/t6.out1
	${TEST_SSH_SSHKEYGEN} -yf $(OBJ)/t6.out1 | diff - $(OBJ)/t6.out2

$(OBJ)/t7.out:
	${TEST_SSH_SSHKEYGEN} -q -t rsa -N '' -f $@

t7: $(OBJ)/t7.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t7.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t7.out > /dev/null

$(OBJ)/t8.out:
	${TEST_SSH_SSHKEYGEN} -q -t dsa -N '' -f $@

t8: $(OBJ)/t8.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t8.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t8.out > /dev/null

$(OBJ)/t9.out:
	test "${TEST_SSH_ECC}" != yes || \
	${TEST_SSH_SSHKEYGEN} -q -t ecdsa -N '' -f $@

t9: $(OBJ)/t9.out
	test "${TEST_SSH_ECC}" != yes || \
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t9.out > /dev/null
	test "${TEST_SSH_ECC}" != yes || \
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t9.out > /dev/null


$(OBJ)/t10.out:
	${TEST_SSH_SSHKEYGEN} -q -t ed25519 -N '' -f $@

t10: $(OBJ)/t10.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t10.out > /dev/null
	${TEST_SSH_SSHKEYGEN} -Bf $(OBJ)/t10.out > /dev/null

t11:
	${TEST_SSH_SSHKEYGEN} -E sha256 -lf ${.CURDIR}/rsa_openssh.pub |\
		awk '{print $$2}' | diff - ${.CURDIR}/t11.ok

$(OBJ)/t12.out:
	${TEST_SSH_SSHKEYGEN} -q -t ed25519 -N '' -C 'test-comment-1234' -f $@

t12: $(OBJ)/t12.out
	${TEST_SSH_SSHKEYGEN} -lf $(OBJ)/t12.out.pub | grep test-comment-1234 >/dev/null

t-exec:	${LTESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	for TEST in ""$?; do \
		echo "run test $${TEST}" ... 1>&2; \
		(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
	done

t-exec-interop:	${INTEROP_TESTS:=.sh}
	@if [ "x$?" = "x" ]; then exit 0; fi; \
	for TEST in ""$?; do \
		echo "run test $${TEST}" ... 1>&2; \
		(env SUDO="${SUDO}" TEST_ENV=${TEST_ENV} ${TEST_SHELL} ${.CURDIR}/test-exec.sh ${.OBJDIR} ${.CURDIR}/$${TEST}) || exit $$?; \
	done

# Not run by default
interop: ${INTEROP_TARGETS}

# Unit tests, built by top-level Makefile
unit:
	set -e ; if test -z "${SKIP_UNIT}" ; then \
		V="" ; \
		test "x${USE_VALGRIND}" = "x" || \
		    V=${.CURDIR}/valgrind-unit.sh ; \
		$$V ${.OBJDIR}/unittests/sshbuf/test_sshbuf ; \
		$$V ${.OBJDIR}/unittests/sshkey/test_sshkey \
			-d ${.CURDIR}/unittests/sshkey/testdata ; \
		$$V ${.OBJDIR}/unittests/bitmap/test_bitmap ; \
		$$V ${.OBJDIR}/unittests/conversion/test_conversion ; \
		$$V ${.OBJDIR}/unittests/kex/test_kex ; \
		$$V ${.OBJDIR}/unittests/hostkeys/test_hostkeys \
			-d ${.CURDIR}/unittests/hostkeys/testdata ; \
		$$V ${.OBJDIR}/unittests/match/test_match ; \
		if test "x${TEST_SSH_UTF8}" = "xyes"  ; then \
			$$V ${.OBJDIR}/unittests/utf8/test_utf8 ; \
		fi \
	fi

=== regress/misc/Makefile ===
SUBDIR=		kexfuzz

.include <bsd.subdir.mk>

=== regress/misc/fuzz-harness/Makefile ===
# NB. libssh and libopenbsd-compat should be built with the same sanitizer opts.
CXX=clang++-3.9
FUZZ_FLAGS=-fsanitize=address,undefined -fsanitize-coverage=edge
FUZZ_LIBS=-lFuzzer

CXXFLAGS=-O2 -g -Wall -Wextra -I ../../.. $(FUZZ_FLAGS)
LDFLAGS=-L ../../.. -L ../../../openbsd-compat -g $(FUZZ_FLAGS)
LIBS=-lssh -lopenbsd-compat -lcrypto $(FUZZ_LIBS)

all: pubkey_fuzz sig_fuzz

.cc.o:
	$(CXX) $(CXXFLAGS) -c $< -o $@

pubkey_fuzz: pubkey_fuzz.o
	$(CXX) -o $@ pubkey_fuzz.o $(LDFLAGS) $(LIBS)

sig_fuzz: sig_fuzz.o
	$(CXX) -o $@ sig_fuzz.o $(LDFLAGS) $(LIBS)

clean:
	-rm -f *.o pubkey_fuzz sig_fuzz

=== regress/misc/kexfuzz/Makefile ===
#	$OpenBSD: Makefile,v 1.2 2017/04/17 11:02:31 jsg Exp $

.include <bsd.own.mk>
.include <bsd.obj.mk>

# XXX detect from ssh binary?
SSH1?=		no
OPENSSL?=	yes

PROG=	kexfuzz
SRCS=	kexfuzz.c
NOMAN=	1

.if (${OPENSSL:L} == "yes")
CFLAGS+=	-DWITH_OPENSSL
.else
# SSH v.1 requires OpenSSL.
SSH1=		no
.endif

.if (${SSH1:L} == "yes")
CFLAGS+=	-DWITH_SSH1
.endif

# enable warnings
WARNINGS=Yes

DEBUG=-g
CFLAGS+=	-fstack-protector-all
CDIAGFLAGS=	-Wall
CDIAGFLAGS+=	-Wextra
CDIAGFLAGS+=	-Werror
CDIAGFLAGS+=	-Wchar-subscripts
CDIAGFLAGS+=	-Wcomment
CDIAGFLAGS+=	-Wformat
CDIAGFLAGS+=	-Wformat-security
CDIAGFLAGS+=	-Wimplicit
CDIAGFLAGS+=	-Winline
CDIAGFLAGS+=	-Wmissing-declarations
CDIAGFLAGS+=	-Wmissing-prototypes
CDIAGFLAGS+=	-Wparentheses
CDIAGFLAGS+=	-Wpointer-arith
CDIAGFLAGS+=	-Wreturn-type
CDIAGFLAGS+=	-Wshadow
CDIAGFLAGS+=	-Wsign-compare
CDIAGFLAGS+=	-Wstrict-aliasing
CDIAGFLAGS+=	-Wstrict-prototypes
CDIAGFLAGS+=	-Wswitch
CDIAGFLAGS+=	-Wtrigraphs
CDIAGFLAGS+=	-Wuninitialized
CDIAGFLAGS+=	-Wunused
.if ${COMPILER_VERSION:L} != "gcc3"
CDIAGFLAGS+=	-Wpointer-sign
CDIAGFLAGS+=	-Wold-style-definition
.endif

SSHREL=../../../../../usr.bin/ssh

CFLAGS+=-I${.CURDIR}/${SSHREL}

.if exists(${.CURDIR}/${SSHREL}/lib/${__objdir})
LDADD+=-L${.CURDIR}/${SSHREL}/lib/${__objdir} -lssh
DPADD+=${.CURDIR}/${SSHREL}/lib/${__objdir}/libssh.a
.else
LDADD+=-L${.CURDIR}/${SSHREL}/lib -lssh
DPADD+=${.CURDIR}/${SSHREL}/lib/libssh.a
.endif

LDADD+= -lutil -lz
DPADD+= ${LIBUTIL} ${LIBZ}

.if (${OPENSSL:L} == "yes")
LDADD+= -lcrypto
DPADD+= ${LIBCRYPTO}
.endif

.include <bsd.prog.mk>

=== regress/unittests/test_helper/Makefile ===
#	$OpenBSD: Makefile,v 1.3 2016/07/04 18:01:44 guenther Exp $

LIB=	test_helper
SRCS=	test_helper.c fuzz.c

NOPROFILE= yes
NOPIC=	yes

# Hack to allow building with SUBDIR in ../../Makefile
regress: all

install:
	@echo -n

.include <bsd.lib.mk>

=== debian/changelog ===
openssh (1:7.6p1-4) unstable; urgency=medium

  * Move VCS to salsa.debian.org.
  * Add a preseeding-only openssh-server/password-authentication debconf
    template that can be used to disable password authentication (closes:
    #878945).

 -- Colin Watson <cjwatson@debian.org>  Sat, 10 Feb 2018 02:31:46 +0000

openssh (1:7.6p1-3) unstable; urgency=medium

  [ Colin Watson ]
  * Remove the decade-old ssh-krb5 transitional package; upgrades of
    openssh-server will preserve existing configuration, and new
    installations should just enable GSSAPIAuthentication and
    GSSAPIKeyExchange in sshd_config (closes: #878626).
  * Support the "noudeb" build profile.
  * Fix putty-transfer regression test.

  [ Anders Kaseorg ]
  * debian/systemd/ssh-agent.service: Add missing dbus dependency.

  [ Jason Duerstock ]
  * Add a "pkg.openssh.nognome" build profile, which disables building the
    ssh-askpass-gnome binary package and avoids the build-dependency on
    libgtk-3-dev (closes: #883819).

 -- Colin Watson <cjwatson@debian.org>  Tue, 16 Jan 2018 17:41:08 +0000

openssh (1:7.6p1-2) unstable; urgency=medium

  * Apply upstream patch to fix PermitOpen argument handling.

 -- Colin Watson <cjwatson@debian.org>  Sat, 07 Oct 2017 13:44:13 +0100

openssh (1:7.6p1-1) unstable; urgency=medium

  * New upstream release (https://www.openssh.com/txt/release-7.6):
    - CVE-2017-15906: sftp-server(8): In read-only mode, sftp-server was
      incorrectly permitting creation of zero-length files. Reported by
      Michal Zalewski.
    - ssh(1): Delete SSH protocol version 1 support, associated
      configuration options and documentation (LP: #1584321).
    - ssh(1)/sshd(8): Remove support for the hmac-ripemd160 MAC.
    - ssh(1)/sshd(8): Remove support for the arcfour, blowfish and CAST
      ciphers.
    - Refuse RSA keys <1024 bits in length and improve reporting for keys
      that do not meet this requirement.
    - ssh(1): Do not offer CBC ciphers by default.
    - ssh(1): Add RemoteCommand option to specify a command in the ssh
      config file instead of giving it on the client's command line.  This
      allows the configuration file to specify the command that will be
      executed on the remote host.
    - sshd(8): Add ExposeAuthInfo option that enables writing details of the
      authentication methods used (including public keys where applicable)
      to a file that is exposed via a $SSH_USER_AUTH environment variable in
      the subsequent session.
    - ssh(1): Add support for reverse dynamic forwarding.  In this mode, ssh
      will act as a SOCKS4/5 proxy and forward connections to destinations
      requested by the remote SOCKS client.  This mode is requested using
      extended syntax for the -R and RemoteForward options and, because it
      is implemented solely at the client, does not require the server be
      updated to be supported.
    - sshd(8): Allow LogLevel directive in sshd_config Match blocks.
    - ssh-keygen(1): Allow inclusion of arbitrary string or flag certificate
      extensions and critical options.
    - ssh-keygen(1): Allow ssh-keygen to use a key held in ssh-agent as a CA
      when signing certificates.
    - ssh(1)/sshd(8): Allow IPQoS=none in ssh/sshd to not set an explicit
      ToS/DSCP value and just use the operating system default.
    - ssh-add(1): Add -q option to make ssh-add quiet on success.
    - ssh(1): Expand the StrictHostKeyChecking option with two new settings.
      The first "accept-new" will automatically accept hitherto-unseen keys
      but will refuse connections for changed or invalid hostkeys.  This is
      a safer subset of the current behaviour of StrictHostKeyChecking=no.
      The second setting "off", is a synonym for the current behaviour of
      StrictHostKeyChecking=no: accept new host keys, and continue
      connection for hosts with incorrect hostkeys.  A future release will
      change the meaning of StrictHostKeyChecking=no to the behaviour of
      "accept-new".
    - ssh(1): Add SyslogFacility option to ssh(1) matching the equivalent
      option in sshd(8).
    - ssh(1): Use HostKeyAlias if specified instead of hostname for matching
      host certificate principal names.
    - sftp(1): Implement sorting for globbed ls.
    - ssh(1): Add a user@host prefix to client's "Permission denied"
      messages, useful in particular when using "stacked" connections (e.g.
      ssh -J) where it's not clear which host is denying.
    - ssh(1): Accept unknown EXT_INFO extension values that contain \0
      characters.  These are legal, but would previously cause fatal
      connection errors if received.
    - sftp(1): Print '?' instead of incorrect link count (that the protocol
      doesn't provide) for remote listings.
    - ssh(1): Return failure rather than fatal() for more cases during
      session multiplexing negotiations.  Causes the session to fall back to
      a non-mux connection if they occur.
    - ssh(1): Mention that the server may send debug messages to explain
      public key authentication problems under some circumstances.
    - Translate OpenSSL error codes to better report incorrect passphrase
      errors when loading private keys.
    - sshd(8): Adjust compatibility patterns for WinSCP to correctly
      identify versions that implement only the legacy DH group exchange
      scheme (closes: #877800).
    - ssh(1): Print the "Killed by signal 1" message only at LogLevel
      verbose so that it is not shown at the default level; prevents it from
      appearing during ssh -J and equivalent ProxyCommand configs.
    - ssh-keygen(1): When generating all hostkeys (ssh-keygen -A), clobber
      existing keys if they exist but are zero length.  Zero-length keys
      could previously be made if ssh-keygen failed or was interrupted part
      way through generating them.
    - ssh-keyscan(1): Avoid double-close() on file descriptors.


=== debian/control ===
--- 
+++ 
@@ -1,17 +1,15 @@
 Source: openssh
 Section: net
 Priority: standard
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
+Maintainer: Debian OpenSSH Maintainers <debian-ssh@lists.debian.org>
 Build-Depends: autotools-dev,
-               debhelper (>= 9~),
+               debhelper (>= 9.20160709~),
                dh-autoreconf,
                dh-exec,
-               dh-systemd (>= 1.4),
                dpkg-dev (>= 1.16.1~),
                libaudit-dev [linux-any],
                libedit-dev,
-               libgtk-3-dev,
+               libgtk-3-dev <!pkg.openssh.nognome>,
                libkrb5-dev | heimdal-dev,
                libpam0g-dev | libpam-dev,
                libselinux1-dev [linux-any],
@@ -19,12 +17,12 @@
                libsystemd-dev [linux-any],
                libwrap0-dev | libwrap-dev,
                zlib1g-dev (>= 1:1.2.3),
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Uploaders: Colin Watson <cjwatson@debian.org>,
            Matthew Vernon <matthew@debian.org>,
 Homepage: http://www.openssh.com/
-Vcs-Git: https://anonscm.debian.org/git/pkg-ssh/openssh.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-ssh/openssh.git
+Vcs-Git: https://salsa.debian.org/ssh-team/openssh
+Vcs-Browser: https://salsa.debian.org/ssh-team/openssh
 
 Package: openssh-client
 Architecture: any
@@ -155,7 +153,7 @@
  are individually implemented as extensions.
 
 Package: ssh
-Priority: extra
+Priority: optional
 Architecture: all
 Pre-Depends: dpkg (>= 1.17.5),
 Depends: openssh-client (>= ${binary:Version}),
@@ -166,24 +164,12 @@
  and the OpenSSH server. It provides nothing in and of itself, so you
  may remove it if nothing depends on it.
 
-Package: ssh-krb5
-Section: oldlibs
-Priority: extra
-Architecture: all
-Depends: openssh-client (>= ${binary:Version}),
-         openssh-server (>= ${binary:Version}),
-         ${misc:Depends},
-Description: secure shell client and server (transitional package)
- This is a transitional package depending on the regular Debian OpenSSH
- client and server, which now support GSSAPI natively. It will add the
- necessary GSSAPI options to the server configuration file. You can
- remove it once the upgrade is complete and nothing depends on it.
-
 Package: ssh-askpass-gnome
+Build-Profiles: <!pkg.openssh.nognome>
 Section: gnome
 Priority: optional
 Architecture: any
-Depends: openssh-client | ssh (>= 1:1.2pre7-4) | ssh-krb5,
+Depends: openssh-client | ssh (>= 1:1.2pre7-4),
          ${misc:Depends},
          ${shlibs:Depends},
 Replaces: ssh (<< 1:3.5p1-3),
@@ -196,6 +182,7 @@
  provided to add to your choice and/or confusion.
 
 Package: openssh-client-udeb
+Build-Profiles: <!noudeb>
 Package-Type: udeb
 Section: debian-installer
 Priority: optional
@@ -210,6 +197,7 @@
  This package provides the ssh client for use in debian-installer.
 
 Package: openssh-server-udeb
+Build-Profiles: <!noudeb>
 Package-Type: udeb
 Section: debian-installer
 Priority: optional

=== debian/rules ===
--- 
+++ 
@@ -132,19 +132,24 @@
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -Bdebian/build-deb -- $(confflags)
+ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
 	dh_auto_configure -Bdebian/build-udeb -- $(confflags_udeb)
-
-override_dh_auto_configure-indep:
-
-override_dh_auto_build-arch:
 	# Avoid libnsl linkage. Ugh.
 	perl -pi -e 's/ +-lnsl//' debian/build-udeb/config.status
 	cd debian/build-udeb && ./config.status
-
+endif
+
+override_dh_auto_configure-indep:
+
+override_dh_auto_build-arch:
 	$(MAKE) -C debian/build-deb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass'
+ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
 	$(MAKE) -C debian/build-udeb $(PARALLEL) ASKPASS_PROGRAM='/usr/bin/ssh-askpass' ssh scp sftp sshd ssh-keygen
-
+endif
+
+ifeq ($(filter pkg.openssh.nognome,$(DEB_BUILD_PROFILES)),)
 	$(MAKE) -C contrib gnome-ssh-askpass3 CC='$(CC) $(CPPFLAGS) $(CFLAGS) -Wall -Wl,--as-needed $(LDFLAGS)' PKG_CONFIG=$(PKG_CONFIG)
+endif
 
 override_dh_auto_build-indep:
 
@@ -178,8 +183,10 @@
 	rm -f debian/tmp/etc/ssh/sshd_config
 
 	dh_install -Nopenssh-client-udeb -Nopenssh-server-udeb --fail-missing
+ifeq ($(filter noudeb,$(DEB_BUILD_PROFILES)),)
 	dh_install -popenssh-client-udeb -popenssh-server-udeb \
 		--sourcedir=debian/build-udeb
+endif
 
 	# Remove version control tags to avoid unnecessary conffile
 	# resolution steps for administrators.

=== debian/tests/control ===
Tests: regress
Restrictions: needs-root allow-stderr
Depends: devscripts,
         haveged,
         openssh-client,
         openssh-server,
         openssh-sftp-server,
         openssl,
         putty-tools (>= 0.67-2),
         python-twisted-conch (>= 1:15.5.0-1),
         sudo,
         sysvinit-utils,
         @builddeps@,

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
http://ftp.openbsd.org/pub/OpenBSD/OpenSSH/portable/openssh-(.*)\.tar\.gz
